CFPRIME MODNET                                                          MODNET      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE MODNET(CARD,IKEY,ISCARD,JTYP,NETTOP,IEBK,LLNET,ISTORE, MODNET      3
     &                  ICRCCT)                                         MODNET      4
CD                                                                      MODNET      5
CD    ONE OF THE NETWORK SWITCHING ROUTINES. IT READS IN THE SWITCHING  MODNET      6
CD    CARDS WRITTEN IN ROUTINE LSWITD AND THEN WRITES OUT SWITCHING     MODNET      7
CD    CARDS THAT WILL BE READ BY UPYMAT.                                MODNET      8
CD                                                                      MODNET      9
                                                                        MODNET     10
      INCLUDE 'PARX.INS'                                                MODNET     11
      INCLUDE 'CNFLAG.INS'                                              MODNET     12
      INCLUDE 'CNPT.INS'                                                MODNET     13
      INCLUDE 'CNIPTR.INS'                                              MODNET     14
      INCLUDE 'CNB0.INS'                                                MODNET     15
      INCLUDE 'CNB1.INS'                                                MODNET     16
      INCLUDE 'CNB3.INS'                                                MODNET     17
      INCLUDE 'CNB4.INS'                                                MODNET     18
      INCLUDE 'CNB8.INS'                                                MODNET     19
      INCLUDE 'CNB19.INS'                                               MODNET     20
      INCLUDE 'CNPARX.INS'                                              MODNET     21
      INCLUDE 'CNNNEW.INS'                                              MODNET     22
      INCLUDE 'CNNETD.INS'                                              MODNET     23
      INCLUDE 'CNAUTO.INS'                                              MODNET     24
      INCLUDE 'CNMON.INS'                                               MODNET     25
      INCLUDE 'CNSELI.INS'                                              MODNET     26
      INCLUDE 'CNLKN1.INS'                                              MODNET     27
      INCLUDE 'CNBRL2.INS'                                              MODNET     28
      INCLUDE 'CNUNIT.INS'                                              MODNET     29
      INCLUDE 'CNSTN.INS'                                               MODNET     30
      INCLUDE 'CNMYVA.INS'                                              MODNET     31
      INCLUDE 'CNYVAR.INS'                                              MODNET     32
      INCLUDE 'CNMASK.INS'                                              MODNET     33
      INCLUDE 'CNULTC.INS'                                              MODNET     34
      INCLUDE 'CNMDAT.INS'                                              MODNET     35
      INCLUDE 'CNMSG.INS'                                               MODNET     36
C                                                                       MODNET     37
      CHARACTER*4 IRADX(MONL*12),IRORIG(MONL*12),IXORIG(MONL*12)        MODNET     38
      EQUIVALENCE                                                       MODNET     39
     &(RADX(1),IRADX(1)),(RORIG(1),IRORIG(1)),(XORIG(1),IXORIG(1))      MODNET     40
      COMPLEX ZCX(20),Y1CX(20),Y2CX(20)                                 MODNET     41
      INTEGER*4 ITFK                                                    MODNET     42
      CHARACTER*2 ICKT,ISCKT,CKK                                        MODNET     43
      DIMENSION KKR1(1),KKR2(1),KKR3(1),KKR4(1),KKR5(1),XKR5(1)         MODNET     44
      EQUIVALENCE (KKR5(1),ISPEED),(XKR5(1),ERTOL)                      MODNET     45
     1,(KKR1(1),LFNO),(KKR2(1),NT),(KKR3(1),NPKPR),(KKR4(1),IALPT)      MODNET     46
      CHARACTER*132 CARD,CARD1                                          MODNET     47
C                                                                       MODNET     48
      DIMENSION NRCLSE(MAXCHM*5)                                        MODNET     49
      EQUIVALENCE( RCLSE(1),NRCLSE(1) )                                 MODNET     50
C                                                                       MODNET     51
      INCLUDE 'CNISOC.INS'                                              MODNET     52
C                                                                       MODNET     53
      LDEB=(JDEB(40).NE.0)                                              MODNET     54
C                                                                       MODNET     55
      OVMG=0.0                                                          MODNET     56
      OVPHS=0.0                                                         MODNET     57
      OVMG1=0.0                                                         MODNET     58
      OVPHS1=0.0                                                        MODNET     59
      OXREAL=0.0                                                        MODNET     60
      OXIMAG=0.0                                                        MODNET     61
      NXL=NL                                                            MODNET     62
      ITRFX=ITRF                                                        MODNET     63
      IF(ISTORE.EQ.2)GOTO 1200                                          MODNET     64
C                                                                       MODNET     65
      ISPR=0                                                            MODNET     66
      IWRITE=0                                                          MODNET     67
      NZLTOP=0                                                          MODNET     68
      IF(IKEY.LE.1)THEN                                                 MODNET     69
      IKEY=2                                                            MODNET     70
      IF (NAWRUC .LE. 0 .OR. IASWCT .GT. NAWRUC+1) THEN                 MODNET     71
C        WRITE(IU17,2300)                                               MODNET     72
        WRITE(IU6,2300)                                                 MODNET     73
      END IF                                                            MODNET     74
       ENDIF                                                            MODNET     75
C                                                                       MODNET     76
C                                                                       MODNET     77
      IF(JTYP.LE.22)GOTO 450                                            MODNET     78
C                                                                       MODNET     79
C       ICRCCT=0                                                        MODNET     80
C                                                                       MODNET     81
C   READ IN ZR,ZA,YK,LGF,LLF,LGR,LLR CARD                               MODNET     82
C                                                                       MODNET     83
      READ(CARD,2000) ITYP,NLFI,XREAL,XIMAG,VMG,VPHS                    MODNET     84
C                                                                       MODNET     85
C   ADD MORE CODE FOR LGF LGR LLF LLR*****************                  MODNET     86
C                                                                       MODNET     87
      ISCARD=ISCARD+1                                                   MODNET     88
      IF(JTYP.EQ.25)THEN                                                MODNET     89
       XXIMAG=-XIMAG                                                    MODNET     90
      ELSE                                                              MODNET     91
       XXIMAG=XIMAG                                                     MODNET     92
      ENDIF                                                             MODNET     93
      WRITE(IU12,2050) JTYP,NLFI,XREAL,XXIMAG,VMG,VPHS                  MODNET     94
C                                                                       MODNET     95
      NOLDI=NOLD(NLFI)                                                  MODNET     96
      II3=NLFI*3                                                        MODNET     97
      II2=II3-1                                                         MODNET     98
      II1=II3-2                                                         MODNET     99
C      WRITE(IU17,2500) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),    MODNET    100
C     1XREAL,XIMAG                                                      MODNET    101
      WRITE(IU6,2500) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),      MODNET    102
     1XREAL,XIMAG                                                       MODNET    103
      GOTO 1100                                                         MODNET    104
C                                                                       MODNET    105
C   READ IN BRANCH CHANGE                                               MODNET    106
C (LA,TA,LPA,LR,TR,LPR,LM,TM,LPM,LSA,LSR,LSM,RCG,FCG) CARDS             MODNET    107
C                                                                       MODNET    108
 450  CONTINUE                                                          MODNET    109
C                                                                       MODNET    110
       ICRCCT=1                                                         MODNET    111
C                                                                       MODNET    112
C    RESTORE THE LOAD FLOW NETWORK AND LINE STATUS                      MODNET    113
C    AND UPDATE ACCORDINGLY                                             MODNET    114
C                                                                       MODNET    115
      IF(ISTORE.EQ.0)THEN                                               MODNET    116
      REWIND IU3                                                        MODNET    117
      READ(IU3) NL,ITRF,NLFBUS                                          MODNET    118
      CALL FLWR(IU3,1,NL*5,GBFT)                                        MODNET    119
      CALL IFWR(IU3,1,NXTR,ITRAN)                                       MODNET    120
      IF(ITRF.NE.0)CALL FLWR(IU3,1,ITRF*2,TRANS)                        MODNET    121
      CALL IHWR(IU3,1,NL,LTRANC)                                        MODNET    122
C                                                                       MODNET    123
C      RESTORE AND UPDATE THE PI-LINE DATA                              MODNET    124
C                                                                       MODNET    125
      IF(NSEL .NE.0)THEN                                                MODNET    126
      READ(IU3)NSEL                                                     MODNET    127
      CALL FLWR(IU3,1,18*NSEL,EQPI)                                     MODNET    128
      CALL FLWR(IU3,1,24*NSEL,PSELIN)                                   MODNET    129
      CALL IHWR(IU3,1,6*NSEL,LCONE)                                     MODNET    130
      CALL IHWR(IU3,1,12*NSEL,NEXTSL)                                   MODNET    131
      ENDIF                                                             MODNET    132
C                                                                       MODNET    133
C       RESTORE THE ORIGINAL LINE MONITOR                               MODNET    134
C                                                                       MODNET    135
      READ(IU3)KNET                                                     MODNET    136
      CALL IFWR(IU3,1,KNET*2,LINEPO)                                    MODNET    137
      CALL IFWR(IU3,1,KNET,IARCCT)                                      MODNET    138
      CALL IFWR(IU3,1,NL,LISMON)                                        MODNET    139
      ISTORE=1                                                          MODNET    140
      ENDIF                                                             MODNET    141
C                                                                       MODNET    142
       READ(CARD,2100)ITYP,NLFI,NLFJ,ICKT,ISCKT,TRCLSE                  MODNET    143
C                                                                       MODNET    144
         NPBNOI=NLFI                                                    MODNET    145
         NPBNOJ=NLFJ                                                    MODNET    146
C                                                                       MODNET    147
         NOLDI=NOLD(NLFI)                                               MODNET    148
         NOLDJ=NOLD(NLFJ)                                               MODNET    149
         II3=NLFI*3                                                     MODNET    150
         II2=II3-1                                                      MODNET    151
         II1=II3-2                                                      MODNET    152
         JJ3=NLFJ*3                                                     MODNET    153
         JJ2=JJ3-1                                                      MODNET    154
         JJ1=JJ3-2                                                      MODNET    155
         WRITE(CARD1,5200)ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),  MODNET    156
     &         NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT              MODNET    157
C                                                                       MODNET    158
      NMLINE=0                                                          MODNET    159
      NJSELI=0                                                          MODNET    160
C                                                                       MODNET    161
      IF(NPBNOI.GT.0.AND.NPBNOJ.GT.0)THEN                               MODNET    162
      CALL LOLIN2(NPBNOI,NPBNOJ,ICKT,JNL)                               MODNET    163
      ELSE                                                              MODNET    164
      JNL=0                                                             MODNET    165
      ENDIF                                                             MODNET    166
C                                                                       MODNET    167
C            1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  MODNET    168
C          ALI ATR APL ABT RLI RTR RPL RBT ASL RSL DLI DTR DPL DLR DBT  MODNET    169
      GOTO(460,460,460,460,520,520,520,520,640,660,700,700,700,700,700  MODNET    170
C                                                                       MODNET    171
C       16  17  18  19  20  21  22                                      MODNET    172
C      DSL MLI MTR MPL MSL RCG FCG                                      MODNET    173
     &,740,560,560,560,680,760,800),JTYP                                MODNET    174
C                                                                       MODNET    175
C     ADDING NEW LINE, TRANSFORMER OR PI LINE                           MODNET    176
C                                                                       MODNET    177
 460  CONTINUE                                                          MODNET    178
C                                                                       MODNET    179
       IF(JNL.NE.0)THEN                                                 MODNET    180
C                                                                       MODNET    181
C   BRANCH EXIST WRITE ERROR MESSAGE                                    MODNET    182
C                                                                       MODNET    183
       IEBK=1                                                           MODNET    184
       WRITE(MSG(1),3000)                                               MODNET    185
       WRITE(MSG(2),3010)                                               MODNET    186
       MSG(3)='     '//CARD1(1:48)                                      MODNET    187
       MSG(4)='     '//CARD1(49:107)                                    MODNET    188
       CALL PRTMSG(4)                                                   MODNET    189
       GOTO 1100                                                        MODNET    190
C                                                                       MODNET    191
       ELSE                                                             MODNET    192
C                                                                       MODNET    193
C   BRANCH DOES NOT EXIST LA AND TA ADD LINE TO LINE AND TRANSFORMER    MODNET    194
C   ARRAY                                                               MODNET    195
C                                                                       MODNET    196
      NETTOP=1                                                          MODNET    197
C                                                                       MODNET    198
      READ(CARD,2200)XREAL,XIMAG,VMG,VPHS,VMG1,VPHS1                    MODNET    199
      NXL=NXL+1                                                         MODNET    200
      LISMON(NXL)=0                                                     MODNET    201
C                                                                       MODNET    202
C    CODE FOR ZIL SWITCHING  ( ABT )                                    MODNET    203
C                                                                       MODNET    204
C      IF(ABS(XREAL).LT.1.0E-6.AND.ABS(XIMAG).LT.ZILTOL)THEN            MODNET    205
C        UPDATE THE LINKNET OF ZIL TABLE                                MODNET    206
C                                                                       MODNET    207
      GMAG=SQRT(XREAL**2+XIMAG**2)                                      MODNET    208
      IF(GMAG.LT.1.0E-6.AND.JTYP.LE.3)THEN                              MODNET    209
      IEBK=1                                                            MODNET    210
       WRITE(MSG(1),3100)                                               MODNET    211
       MSG(2)='     '//CARD1(1:48)                                      MODNET    212
       MSG(3)='     '//CARD1(49:107)                                    MODNET    213
       CALL PRTMSG(3)                                                   MODNET    214
      GOTO 1100                                                         MODNET    215
      ENDIF                                                             MODNET    216
C                                                                       MODNET    217
C   ADD EQPI THAT WAS READ IN                                           MODNET    218
C                                                                       MODNET    219
      IF(JTYP.EQ.3)THEN                                                 MODNET    220
       ISPR=1                                                           MODNET    221
       NSEL=NSEL+1                                                      MODNET    222
       NJSELI=NSEL                                                      MODNET    223
       LCONE(3,NJSELI)=1                                                MODNET    224
       EQPI(1,NSEL)=XREAL                                               MODNET    225
       EQPI(2,NSEL)=XIMAG                                               MODNET    226
       EQPI(3,NSEL)=VMG                                                 MODNET    227
       EQPI(4,NSEL)=VPHS                                                MODNET    228
       EQPI(5,NSEL)=VMG1                                                MODNET    229
       EQPI(6,NSEL)=VPHS1                                               MODNET    230
       ENDIF                                                            MODNET    231
C                                                                       MODNET    232
      JNL5=NXL*5                                                        MODNET    233
C                                                                       MODNET    234
      GA(JNL5-2)=XREAL                                                  MODNET    235
      BA(JNL5-1)=XIMAG                                                  MODNET    236
C                                                                       MODNET    237
      IF(NPBNOI.GT.NPBNOJ)THEN                                          MODNET    238
      NLFK=NLFI                                                         MODNET    239
      NLFI=NLFJ                                                         MODNET    240
      NLFJ=NLFK                                                         MODNET    241
      ENDIF                                                             MODNET    242
C                                                                       MODNET    243
       IF(JTYP.EQ.1)THEN                                                MODNET    244
        BCHG(JNL5)=VMG                                                  MODNET    245
        LTRANC(NXL)=0                                                   MODNET    246
       ENDIF                                                            MODNET    247
C                                                                       MODNET    248
       IF(JTYP.EQ.2)THEN                                                MODNET    249
       IF(NPBNOI.GT.NPBNOJ)VMG=-VMG                                     MODNET    250
       ITRFX=ITRFX+1                                                    MODNET    251
       LTRANC(NXL)=ITRFX                                                MODNET    252
       JTRF2=ITRFX*2                                                    MODNET    253
       RATIO(JTRF2-1)=VMG                                               MODNET    254
       RANG(JTRF2)=VPHS                                                 MODNET    255
       GOTO 860                                                         MODNET    256
       ENDIF                                                            MODNET    257
C                                                                       MODNET    258
C   ADD LINE TO THE LINKNET ARRAYS                                      MODNET    259
C                                                                       MODNET    260
      IF(JTYP.NE.3)NJSELI=0                                             MODNET    261
C                                                                       MODNET    262
      IF(JTYP .EQ. 4)THEN                                               MODNET    263
C                                                                       MODNET    264
C   UPDATE THE ZIL ARRARYS                                              MODNET    265
C                                                                       MODNET    266
            NZI=IMSK(NLFI)                                              MODNET    267
            NZJ=IMSK(NLFJ)                                              MODNET    268
                IF(LDEB)WRITE(IUD6,4500)NZI,NZJ                         MODNET    269
            IF(NZI.GT.0 .AND. NZJ.GT.0)THEN                             MODNET    270
               IF(NLFI.LT.NLFJ)THEN                                     MODNET    271
                  IMSK(NLFI)=NLFI                                       MODNET    272
                  IMSK(NLFJ)=-NLFI                                      MODNET    273
               ELSE                                                     MODNET    274
                  IMSK(NLFJ)=NLFJ                                       MODNET    275
                  IMSK(NLFI)=-NLFJ                                      MODNET    276
               ENDIF                                                    MODNET    277
             ELSEIF(NZI.LT.0 .AND. NZJ.LT.0)THEN                        MODNET    278
               IF(IABS(NZI).GT.IABS(NZJ))THEN                           MODNET    279
                  IMSK(NZI)=-NLFJ                                       MODNET    280
               ELSE                                                     MODNET    281
                  IMSK(NZJ)=-NLFI                                       MODNET    282
               ENDIF                                                    MODNET    283
            ENDIF                                                       MODNET    284
              IF(NZI.EQ.0 .AND. NZJ.NE.0)IMSK(NLFI)=-NLFJ               MODNET    285
              IF(NZJ.EQ.0 .AND. NZI.NE.0)IMSK(NLFJ)=-NLFI               MODNET    286
              IF(NZI.GT.0 .AND. NZJ.LT.0)IMSK(NLFI)=-NLFJ               MODNET    287
              IF(NZI.LT.0 .AND. NZJ.GT.0)IMSK(NLFJ)=-NLFI               MODNET    288
C                                                                       MODNET    289
            IF(NZI.EQ.0 .OR. NZJ.EQ.0)THEN                              MODNET    290
             IF(NLFI.GT.NLAST)NLAST=NLFI                                MODNET    291
             IF(NLFJ.GT.NLAST)NLAST=NLFJ                                MODNET    292
             IF(LDEB)WRITE(IUD6,4600)(IMSK(I),I=1,NLAST)                MODNET    293
            ELSE                                                        MODNET    294
             IF(NLFI.GT.NLAST)NLFBUS=NLFI                               MODNET    295
             IF(NLFJ.GT.NLAST)NLFBUS=NLFJ                               MODNET    296
             IF(LDEB)WRITE(IUD6,4600)(IMSK(I),I=1,NLFBUS)               MODNET    297
            ENDIF                                                       MODNET    298
C                                                                       MODNET    299
       ELSE                                                             MODNET    300
            IF(NLFI.GT.NLAST)NLAST=NLFI                                 MODNET    301
            IF(NLFJ.GT.NLAST)NLAST=NLFJ                                 MODNET    302
            MSK(NLAST)=NLAST                                            MODNET    303
       ENDIF                                                            MODNET    304
C                                                                       MODNET    305
      IF(LDEB)WRITE(IUD6,4700)(LBRI(I),NELI(I),KTNO(I),I=1,LLNET*2)     MODNET    306
C                                                                       MODNET    307
      CALL PACK(ICKT,NJSELI,ITFK)                                       MODNET    308
      LFTB(JNL5-4)=ITFK                                                 MODNET    309
      CALL PACKII(NLFI,NLFJ,IK)                                         MODNET    310
      LFTB(JNL5-3)=IK                                                   MODNET    311
      LLNET=LLNET+1                                                     MODNET    312
      IENDB=LLNET+LLNET                                                 MODNET    313
      IENDA=IENDB-1                                                     MODNET    314
      NELI(IENDA)=LBRI(NLFI)                                            MODNET    315
      LINEPO(IENDA)=NXL                                                 MODNET    316
      LBRI(NLFI)=IENDA                                                  MODNET    317
      KTNO(IENDA)=NLFJ                                                  MODNET    318
      NELI(IENDB)=LBRI(NLFJ)                                            MODNET    319
      LINEPO(IENDB)=-NXL                                                MODNET    320
      LBRI(NLFJ)=IENDB                                                  MODNET    321
      KTNO(IENDB)=NLFI                                                  MODNET    322
      CALL PACK(ICKT,0,ITFK)                                            MODNET    323
      IARCCT(LLNET)=ITFK                                                MODNET    324
C                                                                       MODNET    325
C                                                                       MODNET    326
      IF(JTYP .EQ. 4)THEN                                               MODNET    327
C                                                                       MODNET    328
C  UPDATE THE ZERO IMPEDANCE LINE TABLE                                 MODNET    329
C                                                                       MODNET    330
            NZLINE=NZLINE+1                                             MODNET    331
C                                                                       MODNET    332
            JENDB=NZLINE+NZLINE                                         MODNET    333
            JENDA=JENDB-1                                               MODNET    334
            NZNELI(JENDA)=NZFELI(NLFI)                                  MODNET    335
            NZFELI(NLFI)=JENDA                                          MODNET    336
            NZFENO(JENDA)=NLFJ                                          MODNET    337
            NZNELI(JENDB)=NZFELI(NLFJ)                                  MODNET    338
            NZFELI(NLFJ)=JENDB                                          MODNET    339
            NZFENO(JENDB)=NLFI                                          MODNET    340
C                                                                       MODNET    341
            NZFROM(NZLINE)=NLFI                                         MODNET    342
            NZTO(NZLINE)=NLFJ                                           MODNET    343
            NZCID(NZLINE)=ICKT                                          MODNET    344
            NZLPO(NZLINE)=LLNET                                         MODNET    345
C                                                                       MODNET    346
            NZSWIT(NZLINE)=0                                            MODNET    347
       ENDIF                                                            MODNET    348
C                                                                       MODNET    349
      IF(LDEB)WRITE(IUD6,4800)(LBRI(I),NELI(I),KTNO(I),I=1,LLNET*2)     MODNET    350
C                                                                       MODNET    351
      GOTO 900                                                          MODNET    352
      ENDIF                                                             MODNET    353
 520  CONTINUE                                                          MODNET    354
C                                                                       MODNET    355
C RECONNECT LINE, TRANSFORMER,OR PI LINE                                MODNET    356
C                                                                       MODNET    357
      IF(JNL.EQ.0)THEN                                                  MODNET    358
      IEBK=1                                                            MODNET    359
       WRITE(MSG(1),3200)                                               MODNET    360
       MSG(2)='     '//CARD1(1:48)                                      MODNET    361
       MSG(3)='     '//CARD1(49:107)                                    MODNET    362
       CALL PRTMSG(3)                                                   MODNET    363
      GOTO 1100                                                         MODNET    364
C                                                                       MODNET    365
      ELSE                                                              MODNET    366
C                                                                       MODNET    367
C   BRANCH FOUND                                                        MODNET    368
C                                                                       MODNET    369
      JNL5=IABS(JNL)                                                    MODNET    370
      ITFK=LISMON(JNL5)                                                 MODNET    371
      CALL UPACKI(LSTATU,NMLINE,ITFK)                                   MODNET    372
C                                                                       MODNET    373
C   FOR RLI,RTR, RPL                                                    MODNET    374
C                                                                       MODNET    375
      IF(LSTATU.EQ.0)THEN                                               MODNET    376
C                                                                       MODNET    377
C   ERROR IF ITEM IS CONNECTED ALREADY                                  MODNET    378
C                                                                       MODNET    379
      IEBK=1                                                            MODNET    380
       WRITE(MSG(1),3300)                                               MODNET    381
       MSG(2)='     '//CARD1(1:48)                                      MODNET    382
       MSG(3)='     '//CARD1(49:107)                                    MODNET    383
       CALL PRTMSG(3)                                                   MODNET    384
      GOTO 1100                                                         MODNET    385
C                                                                       MODNET    386
      ELSE                                                              MODNET    387
                                                                        MODNET    388
      LISMON(JNL5)=NMLINE                                               MODNET    389
      JTRF=LTRANC(JNL5)                                                 MODNET    390
      JNL5=JNL5*5                                                       MODNET    391
      ITFK=LFTB(JNL5-4)                                                 MODNET    392
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    393
C                                                                       MODNET    394
      IF(NJSELI.NE.0)JTYP=7                                             MODNET    395
C                                                                       MODNET    396
C     RECONNECTING PI LINE                                              MODNET    397
C                                                                       MODNET    398
         IF(JTYP.EQ.7)THEN                                              MODNET    399
         ISPR=1                                                         MODNET    400
         LCONE(3,NJSELI)=1                                              MODNET    401
         XREAL=EQPI(1,NJSELI)                                           MODNET    402
         XIMAG=EQPI(2,NJSELI)                                           MODNET    403
         VMG=EQPI(3,NJSELI)                                             MODNET    404
         VPHS=EQPI(4,NJSELI)                                            MODNET    405
         VMG1=EQPI(5,NJSELI)                                            MODNET    406
         VPHS1=EQPI(6,NJSELI)                                           MODNET    407
         ITYP=ISOC(7)                                                   MODNET    408
         GOTO 900                                                       MODNET    409
         ENDIF                                                          MODNET    410
C                                                                       MODNET    411
C    RECONNECTING LINE OR TRANSFORMER                                   MODNET    412
C                                                                       MODNET    413
      XREAL=GA(JNL5-2)                                                  MODNET    414
      XIMAG=BA(JNL5-1)                                                  MODNET    415
C                                                                       MODNET    416
      ZMAG=(XREAL*XREAL+XIMAG*XIMAG)                                    MODNET    417
      IF(ZMAG.NE.0.0)THEN                                               MODNET    418
        ZMAG=1.0/SQRT(ZMAG)                                             MODNET    419
      ELSE                                                              MODNET    420
        ZMAG=0.0                                                        MODNET    421
      ENDIF                                                             MODNET    422
C                                                                       MODNET    423
          IF(JTRF.EQ.0)THEN                                             MODNET    424
          VMG=BCHG(JNL5)                                                MODNET    425
          VPHS=0.0                                                      MODNET    426
          VMG1=0.0                                                      MODNET    427
          VPHS1=0.0                                                     MODNET    428
C                                                                       MODNET    429
          IF( ZMAG.LE.ZILTOL)THEN                                       MODNET    430
           ITYP=ISOC(8)                                                 MODNET    431
           JTYP=8                                                       MODNET    432
           XREAL=0.0                                                    MODNET    433
           XIMAG=0.0                                                    MODNET    434
           IF(LDEB)WRITE(IUD6,4900)(IMSK(I),I=1,NLFBUS)                 MODNET    435
C                                                                       MODNET    436
           CALL LONZL(NLFI,NLFJ,ICKT,NZIL,KPLL)                         MODNET    437
           IF(NZIL.EQ.0)THEN                                            MODNET    438
            IEBK=1                                                      MODNET    439
            WRITE(MSG(1),5100)NLFI,NLFJ                                 MODNET    440
            CALL PRTMSG(1)                                              MODNET    441
           ELSE                                                         MODNET    442
C                                                                       MODNET    443
C   UPDATE THE ZIL ARRARYS                                              MODNET    444
C                                                                       MODNET    445
            NETTOP=1                                                    MODNET    446
            NZSWIT(NZIL)=0                                              MODNET    447
            NZI=IMSK(NLFI)                                              MODNET    448
            NZJ=IMSK(NLFJ)                                              MODNET    449
            IF(NZI.GT.0 .AND. NZJ.GT.0)THEN                             MODNET    450
               IF(NZI.LT.NZJ)THEN                                       MODNET    451
                  IMSK(NLFJ)=-NLFI                                      MODNET    452
               ELSE                                                     MODNET    453
                  IMSK(NLFI)=-NLFJ                                      MODNET    454
               ENDIF                                                    MODNET    455
             ELSE                                                       MODNET    456
              IF(NZI .LT. 0)IMSK(NLFJ)=-NLFI                            MODNET    457
              IF(NZJ .LT. 0)IMSK(NLFI)=-NLFJ                            MODNET    458
             ENDIF                                                      MODNET    459
           ENDIF                                                        MODNET    460
           IF(LDEB)WRITE(IUD6,4600)(IMSK(I),I=1,NLFBUS)                 MODNET    461
C                                                                       MODNET    462
          ELSE                                                          MODNET    463
           ITYP=ISOC(5)                                                 MODNET    464
           JTYP=5                                                       MODNET    465
          ENDIF                                                         MODNET    466
C                                                                       MODNET    467
          GOTO 900                                                      MODNET    468
C                                                                       MODNET    469
          ELSE                                                          MODNET    470
C                                                                       MODNET    471
C        TYPE RTR                                                       MODNET    472
C                                                                       MODNET    473
          JTRF2=JTRF*2                                                  MODNET    474
C                                                                       MODNET    475
C         CHANGE ULTC STATUS                                            MODNET    476
C                                                                       MODNET    477
          ITC = JTRULC(JTRF)                                            MODNET    478
          IF (ITC .NE. 0) THEN                                          MODNET    479
            MOULTC(ITC) = 1                                             MODNET    480
          END IF                                                        MODNET    481
C                                                                       MODNET    482
          VMG=RATIO(JTRF2-1)                                            MODNET    483
          VPHS=RANG(JTRF2)                                              MODNET    484
          VMG1=0.0                                                      MODNET    485
          VPHS1=0.0                                                     MODNET    486
          ITYP=ISOC(6)                                                  MODNET    487
          JTYP=6                                                        MODNET    488
          GOTO 860                                                      MODNET    489
C                                                                       MODNET    490
          ENDIF                                                         MODNET    491
C                                                                       MODNET    492
      ENDIF                                                             MODNET    493
C                                                                       MODNET    494
C   ENDIF JNL.EQ.0                                                      MODNET    495
C                                                                       MODNET    496
      ENDIF                                                             MODNET    497
C                                                                       MODNET    498
 560  CONTINUE                                                          MODNET    499
C                                                                       MODNET    500
C     ULTC OPERATION                                                    MODNET    501
C                                                                       MODNET    502
      IF (CARD(4:4) .EQ. 'U') THEN                                      MODNET    503
         JNL5=IABS(JNL)                                                 MODNET    504
         ITFK=LISMON(JNL5)                                              MODNET    505
         CALL UPACKI(III,NMLINE,ITFK)                                   MODNET    506
         READ(CARD,2200)XREAL,XIMAG,VMG,VPHS,VMG1,VPHS1                 MODNET    507
         GBUSX = XREAL                                                  MODNET    508
         BBUSX = XIMAG                                                  MODNET    509
         PHS = -VPHS1/57.29578                                          MODNET    510
         XONR = ABS(VMG1)                                               MODNET    511
         FACT = XONR*XONR                                               MODNET    512
         GKK = GBUSX                                                    MODNET    513
         BKK = -BBUSX                                                   MODNET    514
         GJJ = GBUSX/FACT                                               MODNET    515
         BJJ = -BBUSX/FACT                                              MODNET    516
         COSO = COS(PHS)/XONR                                           MODNET    517
         SINO = SIN(PHS)/XONR                                           MODNET    518
         GJK = -GBUSX*COSO+BBUSX*SINO                                   MODNET    519
         BJK = GBUSX*SINO+BBUSX*COSO                                    MODNET    520
         GKJ = -(GBUSX*COSO+BBUSX*SINO)                                 MODNET    521
         BKJ = -GBUSX*SINO+BBUSX*COSO                                   MODNET    522
         ISCARD=ISCARD+1                                                MODNET    523
         WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GJJ,BJJ,GKK,BKK,     MODNET    524
     &                   GJK,BJK,GKJ,BKJ,NMLINE,NJSELI                  MODNET    525
C                                                                       MODNET    526
         GBUSX = XREAL                                                  MODNET    527
         BBUSX = XIMAG                                                  MODNET    528
         PHS = -VPHS/57.29578                                           MODNET    529
         XONR = ABS(VMG)                                                MODNET    530
         FACT = XONR*XONR                                               MODNET    531
         GKK = GBUSX                                                    MODNET    532
         BKK = -BBUSX                                                   MODNET    533
         GJJ = GBUSX/FACT                                               MODNET    534
         BJJ = -BBUSX/FACT                                              MODNET    535
         COSO = COS(PHS)/XONR                                           MODNET    536
         SINO = SIN(PHS)/XONR                                           MODNET    537
         GJK = -GBUSX*COSO+BBUSX*SINO                                   MODNET    538
         BJK = GBUSX*SINO+BBUSX*COSO                                    MODNET    539
         GKJ = -(GBUSX*COSO+BBUSX*SINO)                                 MODNET    540
         BKJ = -GBUSX*SINO+BBUSX*COSO                                   MODNET    541
         ISCARD=ISCARD+1                                                MODNET    542
         WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GJJ,BJJ,GKK,BKK,     MODNET    543
     &                   GJK,BJK,GKJ,BKJ,NMLINE,NJSELI                  MODNET    544
        GOTO 1100                                                       MODNET    545
      END IF                                                            MODNET    546
C                                                                       MODNET    547
C     MODIFY LINE, TRANSFORMER,OR PI LINE                               MODNET    548
C                                                                       MODNET    549
      IF(JNL.EQ.0)THEN                                                  MODNET    550
      IEBK=1                                                            MODNET    551
       WRITE(MSG(1),3400)                                               MODNET    552
       MSG(2)='     '//CARD1(1:48)                                      MODNET    553
       MSG(3)='     '//CARD1(49:107)                                    MODNET    554
       CALL PRTMSG(3)                                                   MODNET    555
      GOTO 1100                                                         MODNET    556
C                                                                       MODNET    557
      ELSE                                                              MODNET    558
C                                                                       MODNET    559
C     BRANCH FOUND                                                      MODNET    560
C                                                                       MODNET    561
      JNL5=IABS(JNL)                                                    MODNET    562
      ITFK=LISMON(JNL5)                                                 MODNET    563
      CALL UPACKI(LSTATU,NMLINE,ITFK)                                   MODNET    564
C                                                                       MODNET    565
C   FOR MLI,MTR,MPL                                                     MODNET    566
C                                                                       MODNET    567
      IF(LSTATU.EQ.1)THEN                                               MODNET    568
C                                                                       MODNET    569
C   IF ITEM IS DISCONNECTED ALREADY RECONNECT IT                        MODNET    570
C                                                                       MODNET    571
      LISMON(JNL5)=NMLINE                                               MODNET    572
      IFOUND=0                                                          MODNET    573
      ELSE                                                              MODNET    574
      IFOUND=1                                                          MODNET    575
      ENDIF                                                             MODNET    576
C                                                                       MODNET    577
      READ(CARD,2200)XREAL,XIMAG,VMG,VPHS,VMG1,VPHS1                    MODNET    578
C                                                                       MODNET    579
      JTRF=LTRANC(JNL5)                                                 MODNET    580
      JNL5=JNL5*5                                                       MODNET    581
      ITFK=LFTB(JNL5-4)                                                 MODNET    582
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    583
C                                                                       MODNET    584
      IF(NJSELI.NE.0)JTYP=19                                            MODNET    585
C                                                                       MODNET    586
C     MODIFY PI LINE                                                    MODNET    587
C                                                                       MODNET    588
         IF(JTYP.EQ.19)THEN                                             MODNET    589
         ISPR=1                                                         MODNET    590
         OXREAL=EQPI(1,NJSELI)                                          MODNET    591
         OXIMAG=EQPI(2,NJSELI)                                          MODNET    592
         OVMG=EQPI(3,NJSELI)                                            MODNET    593
         OVPHS=EQPI(4,NJSELI)                                           MODNET    594
         OVMG1=EQPI(5,NJSELI)                                           MODNET    595
         OVPHS1=EQPI(6,NJSELI)                                          MODNET    596
C                                                                       MODNET    597
C UPDATE THE LF NETWORK DATA                                            MODNET    598
C                                                                       MODNET    599
C                                                                       MODNET    600
         EQPI(1,NJSELI)=XREAL                                           MODNET    601
         EQPI(2,NJSELI)=XIMAG                                           MODNET    602
         EQPI(3,NJSELI)=VMG                                             MODNET    603
         EQPI(4,NJSELI)=VPHS                                            MODNET    604
         EQPI(5,NJSELI)=VMG1                                            MODNET    605
         EQPI(6,NJSELI)=VPHS1                                           MODNET    606
         ITYP=ISOC(19)                                                  MODNET    607
         JTYP=19                                                        MODNET    608
         GOTO 890                                                       MODNET    609
         ENDIF                                                          MODNET    610
C                                                                       MODNET    611
C    MODIFY LINE OR TRANSFORMER                                         MODNET    612
C                                                                       MODNET    613
      OXREAL=GA(JNL5-2)                                                 MODNET    614
      OXIMAG=BA(JNL5-1)                                                 MODNET    615
C                                                                       MODNET    616
      GA(JNL5-2)=XREAL                                                  MODNET    617
      BA(JNL5-1)=XIMAG                                                  MODNET    618
C                                                                       MODNET    619
          IF(JTRF.EQ.0)THEN                                             MODNET    620
          OVMG=BCHG(JNL5)                                               MODNET    621
          BCHG(JNL5)=VMG                                                MODNET    622
          OVPHS=0.0                                                     MODNET    623
          OVMG1=0.0                                                     MODNET    624
          OVPHS1=0.0                                                    MODNET    625
          ITYP=ISOC(17)                                                 MODNET    626
          JTYP=17                                                       MODNET    627
          GOTO 890                                                      MODNET    628
C                                                                       MODNET    629
          ELSE                                                          MODNET    630
C                                                                       MODNET    631
C        TYPE TR                                                        MODNET    632
C                                                                       MODNET    633
          JTRF2=JTRF*2                                                  MODNET    634
C                                                                       MODNET    635
C         MODIFY ULTC BRANCH PARAMETERS                                 MODNET    636
C                                                                       MODNET    637
          ITC = JTRULC(JTRF)                                            MODNET    638
          IF(ITC.GT.0)THEN                                              MODNET    639
           JTC = JULTCD(ITC)                                            MODNET    640
           DDAT(JTC+20) = XREAL                                         MODNET    641
           DDAT(JTC+21) = XIMAG                                         MODNET    642
          ENDIF                                                         MODNET    643
C                                                                       MODNET    644
          OVMG=RATIO(JTRF2-1)                                           MODNET    645
          OVPHS=RANG(JTRF2)                                             MODNET    646
          RATIO(JTRF2-1)=VMG                                            MODNET    647
          RANG(JTRF2)=VPHS                                              MODNET    648
          OVMG1=0.0                                                     MODNET    649
          OVPHS1=0.0                                                    MODNET    650
          ITYP=ISOC(18)                                                 MODNET    651
          JTYP=18                                                       MODNET    652
          GOTO 860                                                      MODNET    653
C                                                                       MODNET    654
          ENDIF                                                         MODNET    655
C                                                                       MODNET    656
C   ENDIF JNL.EQ.0                                                      MODNET    657
C                                                                       MODNET    658
      ENDIF                                                             MODNET    659
C                                                                       MODNET    660
 640  CONTINUE                                                          MODNET    661
C                                                                       MODNET    662
C  ADD SECTIONAL LINE  AT PRESENCE, THE PROGRAM DOES NOT HAVE THIS CAPABMODNET    663
C                                                                       MODNET    664
      IEBK=1                                                            MODNET    665
       WRITE(MSG(1),3500)                                               MODNET    666
       MSG(2)='     '//CARD1(1:48)                                      MODNET    667
       MSG(3)='     '//CARD1(49:107)                                    MODNET    668
       CALL PRTMSG(3)                                                   MODNET    669
      GOTO 1100                                                         MODNET    670
C                                                                       MODNET    671
 660  CONTINUE                                                          MODNET    672
C                                                                       MODNET    673
C RECONNECTING SECTIONAL LINE TYPE RSL                                  MODNET    674
C THIS OPITON ALLOWS ONLY THE RECONNECTING OF ENTIRE LINE               MODNET    675
C                                                                       MODNET    676
      IF(JNL.EQ.0)THEN                                                  MODNET    677
      IEBK=1                                                            MODNET    678
       WRITE(MSG(1),3600)                                               MODNET    679
       MSG(2)='     '//CARD1(1:48)                                      MODNET    680
       MSG(3)='     '//CARD1(49:107)                                    MODNET    681
       CALL PRTMSG(3)                                                   MODNET    682
      GOTO 1100                                                         MODNET    683
      ENDIF                                                             MODNET    684
C                                                                       MODNET    685
C   BRANCH FOUND                                                        MODNET    686
C                                                                       MODNET    687
      JNL5=IABS(JNL)                                                    MODNET    688
      ITFK=LISMON(JNL5)                                                 MODNET    689
      CALL UPACKI(LSTATU,NMLINE,ITFK)                                   MODNET    690
C                                                                       MODNET    691
      IF(LSTATU.EQ.0)THEN                                               MODNET    692
C                                                                       MODNET    693
C   ERROR IF ITEM IS CONNECTED ALREADY                                  MODNET    694
C                                                                       MODNET    695
      IEBK=1                                                            MODNET    696
       WRITE(MSG(1),3700)                                               MODNET    697
       WRITE(MSG(2),3010)                                               MODNET    698
       MSG(3)='     '//CARD1(1:48)                                      MODNET    699
       MSG(4)='     '//CARD1(49:107)                                    MODNET    700
       CALL PRTMSG(4)                                                   MODNET    701
      GOTO 1100                                                         MODNET    702
C                                                                       MODNET    703
      ENDIF                                                             MODNET    704
                                                                        MODNET    705
      JNL4=JNL5*5                                                       MODNET    706
      ITFK=LFTB(JNL4-4)                                                 MODNET    707
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    708
C                                                                       MODNET    709
      IF(NJSELI.EQ.0)THEN                                               MODNET    710
      JTYP=5                                                            MODNET    711
      ITYP=ISOC(5)                                                      MODNET    712
      GOTO 520                                                          MODNET    713
      ENDIF                                                             MODNET    714
C                                                                       MODNET    715
      LISMON(JNL5)=NMLINE                                               MODNET    716
C                                                                       MODNET    717
      IF(LCONE(3,NJSELI).NE.0)THEN                                      MODNET    718
      IEBK=1                                                            MODNET    719
       WRITE(MSG(1),3800)                                               MODNET    720
       WRITE(MSG(2),3010)                                               MODNET    721
       MSG(3)='     '//CARD1(1:48)                                      MODNET    722
       MSG(4)='     '//CARD1(49:107)                                    MODNET    723
       CALL PRTMSG(4)                                                   MODNET    724
      GOTO 1100                                                         MODNET    725
      ENDIF                                                             MODNET    726
C                                                                       MODNET    727
      LCONE(3,NJSELI)=1                                                 MODNET    728
      XREAL=EQPI(1,NJSELI)                                              MODNET    729
      XIMAG=EQPI(2,NJSELI)                                              MODNET    730
      VMG=EQPI(3,NJSELI)                                                MODNET    731
      VPHS=EQPI(4,NJSELI)                                               MODNET    732
      VMG1=EQPI(5,NJSELI)                                               MODNET    733
      VPHS1=EQPI(6,NJSELI)                                              MODNET    734
      GOTO 900                                                          MODNET    735
C                                                                       MODNET    736
 680  CONTINUE                                                          MODNET    737
C                                                                       MODNET    738
C  MODIFY SECTIONAL LINE  AT PRESENCE,                                  MODNET    739
C  THE PROGRAM DOES NOT HAVE THIS CAPABILITY                            MODNET    740
C                                                                       MODNET    741
      IEBK=1                                                            MODNET    742
       WRITE(MSG(1),3900)                                               MODNET    743
       MSG(2)='     '//CARD1(1:48)                                      MODNET    744
       MSG(3)='     '//CARD1(49:107)                                    MODNET    745
       CALL PRTMSG(3)                                                   MODNET    746
      GOTO 1100                                                         MODNET    747
C                                                                       MODNET    748
C                                                                       MODNET    749
 700  CONTINUE                                                          MODNET    750
C                                                                       MODNET    751
C DISCONNECT LINE,TRANSFORMER AND PI LINE                               MODNET    752
C                                                                       MODNET    753
      IF(JNL.EQ.0)THEN                                                  MODNET    754
      IEBK=1                                                            MODNET    755
       WRITE(MSG(1),4000)                                               MODNET    756
       WRITE(MSG(2),3010)                                               MODNET    757
       MSG(3)='     '//CARD1(1:48)                                      MODNET    758
       MSG(4)='     '//CARD1(49:107)                                    MODNET    759
       CALL PRTMSG(4)                                                   MODNET    760
      GOTO 1100                                                         MODNET    761
C                                                                       MODNET    762
      ELSE                                                              MODNET    763
C                                                                       MODNET    764
C   BRANCH FOUND                                                        MODNET    765
C                                                                       MODNET    766
      JNL5=IABS(JNL)                                                    MODNET    767
      ITFK=LISMON(JNL5)                                                 MODNET    768
      CALL UPACKI(LSTATU,NMLINE,ITFK)                                   MODNET    769
C                                                                       MODNET    770
C   FOR DLI,DTR,DPL                                                     MODNET    771
C                                                                       MODNET    772
      IF(LSTATU.EQ.1)THEN                                               MODNET    773
C                                                                       MODNET    774
C   ERROR IF ITEM HAS BEEN DISCONNECTED ALREADY                         MODNET    775
C                                                                       MODNET    776
       IF(IASWX.EQ.0)IEBK=1                                             MODNET    777
       WRITE(MSG(1),4100)                                               MODNET    778
       WRITE(MSG(2),3010)                                               MODNET    779
       MSG(3)='     '//CARD1(1:48)                                      MODNET    780
       MSG(4)='     '//CARD1(49:107)                                    MODNET    781
       CALL PRTMSG(4)                                                   MODNET    782
      GOTO 1100                                                         MODNET    783
C                                                                       MODNET    784
      ELSE                                                              MODNET    785
      CALL PACKII(1,NMLINE,ITFK)                                        MODNET    786
      LISMON(JNL5)=ITFK                                                 MODNET    787
      JTRF=LTRANC(JNL5)                                                 MODNET    788
      JNL5=JNL5*5                                                       MODNET    789
      ITFK=LFTB(JNL5-4)                                                 MODNET    790
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    791
C                                                                       MODNET    792
C      ADD  CODE TO CREATE THE AUTO RECLOSING TABLE                     MODNET    793
C                                                                       MODNET    794
      IF( JTYP .EQ. 14)THEN                                             MODNET    795
        NDLR=NDLR+1                                                     MODNET    796
        NNDLR=NDLR*5                                                    MODNET    797
        NRCLSE(NNDLR-4)=NLFI                                            MODNET    798
        NRCLSE(NNDLR-3)=NLFJ                                            MODNET    799
        CALL PACK(ICKT,1,ITFK)                                          MODNET    800
        NRCLSE(NNDLR-2)=ITFK                                            MODNET    801
        NRCLSE(NNDLR-1)=NJSELI                                          MODNET    802
        RCLSE(NNDLR)=TS+TRCLSE                                          MODNET    803
       ENDIF                                                            MODNET    804
C                                                                       MODNET    805
C      IF(NJSELI.NE.0)JTYP=11                                           MODNET    806
C                                                                       MODNET    807
C     DISCONNECTING PI LINE                                             MODNET    808
C                                                                       MODNET    809
         IF(NJSELI .NE. 0)THEN                                          MODNET    810
         ISPR=1                                                         MODNET    811
         XREAL=EQPI(1,NJSELI)                                           MODNET    812
         XIMAG=EQPI(2,NJSELI)                                           MODNET    813
         VMG=EQPI(3,NJSELI)                                             MODNET    814
         VPHS=EQPI(4,NJSELI)                                            MODNET    815
         VMG1=EQPI(5,NJSELI)                                            MODNET    816
         VPHS1=EQPI(6,NJSELI)                                           MODNET    817
         ITYP=ISOC(JTYP)                                                MODNET    818
         GOTO 900                                                       MODNET    819
         ENDIF                                                          MODNET    820
C                                                                       MODNET    821
C    DISCONNECTING LINE OR TRANSFORMER                                  MODNET    822
C                                                                       MODNET    823
      XREAL=GA(JNL5-2)                                                  MODNET    824
      XIMAG=BA(JNL5-1)                                                  MODNET    825
C                                                                       MODNET    826
      ZMAG=(XREAL*XREAL+XIMAG*XIMAG)                                    MODNET    827
      IF(ZMAG.NE.0.0)THEN                                               MODNET    828
        ZMAG=1.0/SQRT(ZMAG)                                             MODNET    829
      ELSE                                                              MODNET    830
        ZMAG=0.0                                                        MODNET    831
      ENDIF                                                             MODNET    832
C                                                                       MODNET    833
        IF(LDEB)WRITE(IUD6,5000)XREAL,XIMAG                             MODNET    834
C                                                                       MODNET    835
          IF(JTRF.EQ.0)THEN                                             MODNET    836
          VMG=BCHG(JNL5)                                                MODNET    837
C                                                                       MODNET    838
          IF(ZMAG.LE.ZILTOL)THEN                                        MODNET    839
           XREAL=0.0                                                    MODNET    840
           XIMAG=0.0                                                    MODNET    841
           IF(LDEB)WRITE(IUD6,4900)(IMSK(I),I=1,NLFBUS)                 MODNET    842
C                                                                       MODNET    843
           CALL LONZL(NLFI,NLFJ,ICKT,NZIL,NKLL)                         MODNET    844
           IF(NZIL.EQ.0)THEN                                            MODNET    845
            IEBK=1                                                      MODNET    846
            WRITE(MSG(1),5100)NLFI,NLFJ                                 MODNET    847
            CALL PRTMSG(1)                                              MODNET    848
           ELSE                                                         MODNET    849
            NETTOP=1                                                    MODNET    850
            NZSWIT(NZIL)=1                                              MODNET    851
            NZI=IMSK(NLFI)                                              MODNET    852
            NZJ=IMSK(NLFJ)                                              MODNET    853
 710        CONTINUE                                                    MODNET    854
            NZI=IMSK(IABS(NZI))                                         MODNET    855
            NZJ=IMSK(IABS(NZJ))                                         MODNET    856
            IF(NZI.LT.0 .AND. NZJ .LT. 0)GOTO 710                       MODNET    857
            IF(NZI.GT.0)IMSK(NLFJ)=NLFJ                                 MODNET    858
            IF(NZJ.GT.0)IMSK(NLFI)=NLFI                                 MODNET    859
           ENDIF                                                        MODNET    860
C =                                                                     MODNET    861
           IF(LDEB)WRITE(IUD6,4600)(IMSK(I),I=1,NLFBUS)                 MODNET    862
C                                                                       MODNET    863
            ITYP=ISOC(15)                                               MODNET    864
            JTYP=15                                                     MODNET    865
          ELSE IF( JTYP .EQ. 14)THEN                                    MODNET    866
            ITYP=ISOC(14)                                               MODNET    867
          ELSE                                                          MODNET    868
            ITYP=ISOC(11)                                               MODNET    869
            JTYP=11                                                     MODNET    870
          ENDIF                                                         MODNET    871
C                                                                       MODNET    872
          VPHS=0.0                                                      MODNET    873
          VMG1=0.0                                                      MODNET    874
          VPHS1=0.0                                                     MODNET    875
          GOTO 900                                                      MODNET    876
C                                                                       MODNET    877
          ELSE                                                          MODNET    878
C                                                                       MODNET    879
C        TYPE DTR                                                       MODNET    880
C                                                                       MODNET    881
          JTRF2=JTRF*2                                                  MODNET    882
C                                                                       MODNET    883
C         CHANGE ULTC STATUS                                            MODNET    884
C                                                                       MODNET    885
          ITC = JTRULC(JTRF)                                            MODNET    886
          IF (ITC .NE. 0) THEN                                          MODNET    887
            MOULTC(ITC) = 0                                             MODNET    888
          END IF                                                        MODNET    889
C                                                                       MODNET    890
          VMG=RATIO(JTRF2-1)                                            MODNET    891
          VPHS=RANG(JTRF2)                                              MODNET    892
          VMG1=0.0                                                      MODNET    893
          VPHS1=0.0                                                     MODNET    894
          ITYP=ISOC(12)                                                 MODNET    895
          JTYP=12                                                       MODNET    896
          GOTO 860                                                      MODNET    897
C                                                                       MODNET    898
          ENDIF                                                         MODNET    899
C                                                                       MODNET    900
      ENDIF                                                             MODNET    901
C                                                                       MODNET    902
C   ENDIF JNL.EQ.0                                                      MODNET    903
C                                                                       MODNET    904
      ENDIF                                                             MODNET    905
C                                                                       MODNET    906
 740  CONTINUE                                                          MODNET    907
C                                                                       MODNET    908
C DISCONNECTING SECTIONAL LINE TYPE DSL                                 MODNET    909
C THIS OPITON ALLOWS ONLY THE REMOVING OF ENTIRE LINE                   MODNET    910
C                                                                       MODNET    911
      IF(JNL.EQ.0)THEN                                                  MODNET    912
      IEBK=1                                                            MODNET    913
       WRITE(MSG(1),3500)                                               MODNET    914
       MSG(2)='     '//CARD1(1:48)                                      MODNET    915
       MSG(3)='     '//CARD1(49:107)                                    MODNET    916
       CALL PRTMSG(3)                                                   MODNET    917
      GOTO 1100                                                         MODNET    918
      ENDIF                                                             MODNET    919
C                                                                       MODNET    920
C   BRANCH FOUND                                                        MODNET    921
C                                                                       MODNET    922
      JNL5=IABS(JNL)                                                    MODNET    923
      ITFK=LISMON(JNL5)                                                 MODNET    924
      CALL UPACKI(LSTATU,NMLINE,ITFK)                                   MODNET    925
C                                                                       MODNET    926
      IF(LSTATU.EQ.1)THEN                                               MODNET    927
C                                                                       MODNET    928
C   ERROR IF ITEM IS DISCONNECTED ALREADY                               MODNET    929
C                                                                       MODNET    930
      IEBK=1                                                            MODNET    931
       WRITE(MSG(1),4200)                                               MODNET    932
       WRITE(MSG(2),3010)                                               MODNET    933
       MSG(3)='     '//CARD1(1:48)                                      MODNET    934
       MSG(4)='     '//CARD1(49:107)                                    MODNET    935
       MSG(4)='     '//CARD(67:132)                                     MODNET    936
       CALL PRTMSG(4)                                                   MODNET    937
      GOTO 1100                                                         MODNET    938
C                                                                       MODNET    939
      ENDIF                                                             MODNET    940
C                                                                       MODNET    941
      JNL4=JNL5*5                                                       MODNET    942
      ITFK=LFTB(JNL4-4)                                                 MODNET    943
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    944
C                                                                       MODNET    945
      IF(NJSELI.EQ.0)THEN                                               MODNET    946
      JTYP=11                                                           MODNET    947
      ITYP=ISOC(11)                                                     MODNET    948
      GOTO 700                                                          MODNET    949
      ENDIF                                                             MODNET    950
C                                                                       MODNET    951
      CALL PACKII(1,NMLINE,ITFK)                                        MODNET    952
      LISMON(JNL5)=ITFK                                                 MODNET    953
C                                                                       MODNET    954
      IF(LCONE(3,NJSELI).NE.1)THEN                                      MODNET    955
      IEBK=1                                                            MODNET    956
       WRITE(MSG(1),4200)                                               MODNET    957
       WRITE(MSG(2),3010)                                               MODNET    958
       MSG(3)='     '//CARD1(1:48)                                      MODNET    959
       MSG(4)='     '//CARD1(49:107)                                    MODNET    960
       CALL PRTMSG(4)                                                   MODNET    961
      GOTO 1100                                                         MODNET    962
      ENDIF                                                             MODNET    963
C                                                                       MODNET    964
      ISPR=1                                                            MODNET    965
      LCONE(3,NJSELI)=0                                                 MODNET    966
      XREAL=EQPI(1,NJSELI)                                              MODNET    967
      XIMAG=EQPI(2,NJSELI)                                              MODNET    968
      VMG=EQPI(3,NJSELI)                                                MODNET    969
      VPHS=EQPI(4,NJSELI)                                               MODNET    970
      VMG1=EQPI(5,NJSELI)                                               MODNET    971
      VPHS1=EQPI(6,NJSELI)                                              MODNET    972
      GOTO 900                                                          MODNET    973
C                                                                       MODNET    974
 760  CONTINUE                                                          MODNET    975
C                                                                       MODNET    976
C     RECONNECT FLASHED CAPACITOR TYPE RCG                              MODNET    977
C                                                                       MODNET    978
      IF(JNL.EQ.0)THEN                                                  MODNET    979
      IEBK=1                                                            MODNET    980
       WRITE(MSG(1),3600)                                               MODNET    981
       MSG(2)='     '//CARD1(1:48)                                      MODNET    982
       MSG(3)='     '//CARD1(49:107)                                    MODNET    983
       CALL PRTMSG(3)                                                   MODNET    984
      GOTO 1100                                                         MODNET    985
      ENDIF                                                             MODNET    986
C                                                                       MODNET    987
C   BRANCH FOUND                                                        MODNET    988
C                                                                       MODNET    989
      ISPR=1                                                            MODNET    990
      JNL5=IABS(JNL)                                                    MODNET    991
      ITFK=LISMON(JNL5)                                                 MODNET    992
      CALL UPACKI(JJJ,NMLINE,ITFK)                                      MODNET    993
      JTRF=LTRANC(JNL5)                                                 MODNET    994
      JNL5=JNL5*5                                                       MODNET    995
      ITFK=LFTB(JNL5-4)                                                 MODNET    996
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET    997
C                                                                       MODNET    998
         IPOS=LCONE(5,NJSELI)                                           MODNET    999
         IPOS1=IPOS+LCONE(6,NJSELI)-1                                   MODNET   1000
C                                                                       MODNET   1001
         KSECT=0                                                        MODNET   1002
C                                                                       MODNET   1003
         IF(IPOS.EQ.IPOS1)THEN                                          MODNET   1004
           IF(PSELIN(2,IPOS).GT.0)THEN                                  MODNET   1005
             IEBK=1                                                     MODNET   1006
             WRITE(MSG(1),3600)                                         MODNET   1007
             MSG(2)='     '//CARD1(1:48)                                MODNET   1008
             MSG(3)='     '//CARD1(49:107)                              MODNET   1009
             CALL PRTMSG(3)                                             MODNET   1010
             GOTO 1100                                                  MODNET   1011
           ENDIF                                                        MODNET   1012
           NEXTSL(3,IPOS)=0                                             MODNET   1013
           OXREAL=EQPI(7,NJSELI)                                        MODNET   1014
           OXIMAG=EQPI(8,NJSELI)                                        MODNET   1015
           OVMG=EQPI(9,NJSELI)                                          MODNET   1016
           OVPHS=EQPI(10,NJSELI)                                        MODNET   1017
           OVMG1=EQPI(11,NJSELI)                                        MODNET   1018
           OVPHS1=EQPI(12,NJSELI)                                       MODNET   1019
           XREAL=EQPI(1,NJSELI)                                         MODNET   1020
           XIMAG=EQPI(2,NJSELI)                                         MODNET   1021
           VMG=EQPI(3,NJSELI)                                           MODNET   1022
           VPHS=EQPI(4,NJSELI)                                          MODNET   1023
           VMG1=EQPI(5,NJSELI)                                          MODNET   1024
           VPHS1=EQPI(6,NJSELI)                                         MODNET   1025
           KSECT=1                                                      MODNET   1026
           GOTO 840                                                     MODNET   1027
         ENDIF                                                          MODNET   1028
C                                                                       MODNET   1029
         DO 780 II=IPOS,IPOS1                                           MODNET   1030
C                                                                       MODNET   1031
         IF(CNEXTS(2,II).EQ.ISCKT)THEN                                  MODNET   1032
C                                                                       MODNET   1033
C   FOR THE SPECIFIED SECTION                                           MODNET   1034
C                                                                       MODNET   1035
             IF(PSELIN(1,II).EQ.0.0.AND.PSELIN(2,II).LT.0.0             MODNET   1036
     &       .AND.PSELIN(3,II).EQ.0.0.AND.PSELIN(4,II).EQ.0.0           MODNET   1037
     &       .AND.PSELIN(5,II).EQ.0.0.AND.PSELIN(6,II).EQ.0.0)THEN      MODNET   1038
C                                                                       MODNET   1039
                IF(NEXTSL(3,II).NE.1)THEN                               MODNET   1040
                IEBK=1                                                  MODNET   1041
       WRITE(MSG(1),4300)                                               MODNET   1042
       MSG(2)='     '//CARD1(1:48)                                      MODNET   1043
       MSG(3)='     '//CARD1(49:107)                                    MODNET   1044
       CALL PRTMSG(3)                                                   MODNET   1045
                GOTO 1100                                               MODNET   1046
                ELSE                                                    MODNET   1047
C                                                                       MODNET   1048
C     INTERCHANGE THE EQPI FOR RESTORING THE SERIES CAP                 MODNET   1049
C                                                                       MODNET   1050
                NEXTSL(3,II)=0                                          MODNET   1051
                OXREAL=EQPI(7,NJSELI)                                   MODNET   1052
                OXIMAG=EQPI(8,NJSELI)                                   MODNET   1053
                OVMG=EQPI(9,NJSELI)                                     MODNET   1054
                OVPHS=EQPI(10,NJSELI)                                   MODNET   1055
                OVMG1=EQPI(11,NJSELI)                                   MODNET   1056
                OVPHS1=EQPI(12,NJSELI)                                  MODNET   1057
                XREAL=EQPI(1,NJSELI)                                    MODNET   1058
                XIMAG=EQPI(2,NJSELI)                                    MODNET   1059
                VMG=EQPI(3,NJSELI)                                      MODNET   1060
                VPHS=EQPI(4,NJSELI)                                     MODNET   1061
                VMG1=EQPI(5,NJSELI)                                     MODNET   1062
                VPHS1=EQPI(6,NJSELI)                                    MODNET   1063
                KSECT=1                                                 MODNET   1064
C                                                                       MODNET   1065
                ENDIF                                                   MODNET   1066
            ENDIF                                                       MODNET   1067
         ENDIF                                                          MODNET   1068
 780      CONTINUE                                                      MODNET   1069
C                                                                       MODNET   1070
             IF(KSECT.EQ.0)THEN                                         MODNET   1071
             IEBK=1                                                     MODNET   1072
       WRITE(MSG(1),3600)                                               MODNET   1073
       MSG(2)='     '//CARD1(1:48)                                      MODNET   1074
       MSG(3)='     '//CARD1(49:107)                                    MODNET   1075
       CALL PRTMSG(3)                                                   MODNET   1076
             GOTO 1100                                                  MODNET   1077
             ENDIF                                                      MODNET   1078
C                                                                       MODNET   1079
         GOTO 840                                                       MODNET   1080
C                                                                       MODNET   1081
C                                                                       MODNET   1082
 800  CONTINUE                                                          MODNET   1083
C                                                                       MODNET   1084
C   FLASH CAPACITOR GAP TYPE FCG                                        MODNET   1085
C                                                                       MODNET   1086
      IF(JNL.EQ.0)THEN                                                  MODNET   1087
      IEBK=1                                                            MODNET   1088
       WRITE(MSG(1),3600)                                               MODNET   1089
       MSG(2)='     '//CARD1(1:48)                                      MODNET   1090
       MSG(3)='     '//CARD1(49:107)                                    MODNET   1091
       CALL PRTMSG(3)                                                   MODNET   1092
      GOTO 1100                                                         MODNET   1093
      ENDIF                                                             MODNET   1094
C                                                                       MODNET   1095
C   BRANCH FOUND                                                        MODNET   1096
C                                                                       MODNET   1097
      ISPR=1                                                            MODNET   1098
      JNL5=IABS(JNL)                                                    MODNET   1099
      ITFK=LISMON(JNL5)                                                 MODNET   1100
      CALL UPACKI(JJJ,NMLINE,ITFK)                                      MODNET   1101
      JTRF=LTRANC(JNL5)                                                 MODNET   1102
      JNL5=JNL5*5                                                       MODNET   1103
      ITFK=LFTB(JNL5-4)                                                 MODNET   1104
      CALL UNPACK(CKK,NJSELI,ITFK)                                      MODNET   1105
C                                                                       MODNET   1106
         IPOS=LCONE(5,NJSELI)                                           MODNET   1107
         IPOS1=IPOS+LCONE(6,NJSELI)-1                                   MODNET   1108
C                                                                       MODNET   1109
         ISECT=1                                                        MODNET   1110
         KSECT=0                                                        MODNET   1111
         IF(IPOS.EQ.IPOS1)THEN                                          MODNET   1112
            IF(PSELIN(2,IPOS).GT.0)THEN                                 MODNET   1113
              IEBK=1                                                    MODNET   1114
              WRITE(MSG(1),3600)                                        MODNET   1115
              MSG(2)='     '//CARD1(1:48)                               MODNET   1116
              MSG(3)='     '//CARD1(49:107)                             MODNET   1117
              CALL PRTMSG(3)                                            MODNET   1118
              GOTO 1100                                                 MODNET   1119
            ENDIF                                                       MODNET   1120
            NEXTSL(3,IPOS)=1                                            MODNET   1121
            OXREAL=EQPI(1,NJSELI)                                       MODNET   1122
            OXIMAG=EQPI(2,NJSELI)                                       MODNET   1123
            OVMG=EQPI(3,NJSELI)                                         MODNET   1124
            OVPHS=EQPI(4,NJSELI)                                        MODNET   1125
            OVMG1=EQPI(5,NJSELI)                                        MODNET   1126
            OVPHS1=EQPI(6,NJSELI)                                       MODNET   1127
            KSECT=1                                                     MODNET   1128
            GOTO 825                                                    MODNET   1129
         ENDIF                                                          MODNET   1130
C                                                                       MODNET   1131
         DO 820 II=IPOS,IPOS1                                           MODNET   1132
C                                                                       MODNET   1133
          IF(CNEXTS(2,II).EQ.ISCKT)THEN                                 MODNET   1134
C                                                                       MODNET   1135
C   FOR THE SPECIFIED SECTION                                           MODNET   1136
C                                                                       MODNET   1137
          KSECT=1                                                       MODNET   1138
             IF(PSELIN(1,II).EQ.0.0.AND.PSELIN(2,II).LT.0.0             MODNET   1139
     &       .AND.PSELIN(3,II).EQ.0.0.AND.PSELIN(4,II).EQ.0.0           MODNET   1140
     &       .AND.PSELIN(5,II).EQ.0.0.AND.PSELIN(6,II).EQ.0.0)THEN      MODNET   1141
C                                                                       MODNET   1142
C    FOR THE CAPACITOR SECTION                                          MODNET   1143
C                                                                       MODNET   1144
                IF(NEXTSL(3,II).NE.0)THEN                               MODNET   1145
                IEBK=1                                                  MODNET   1146
       WRITE(MSG(1),4400)                                               MODNET   1147
       MSG(2)='     '//CARD1(1:48)                                      MODNET   1148
       MSG(3)='     '//CARD1(49:107)                                    MODNET   1149
       CALL PRTMSG(3)                                                   MODNET   1150
                GOTO 1100                                               MODNET   1151
                ELSE                                                    MODNET   1152
                NEXTSL(3,II)=1                                          MODNET   1153
                OXREAL=EQPI(1,NJSELI)                                   MODNET   1154
                OXIMAG=EQPI(2,NJSELI)                                   MODNET   1155
                OVMG=EQPI(3,NJSELI)                                     MODNET   1156
                OVPHS=EQPI(4,NJSELI)                                    MODNET   1157
                OVMG1=EQPI(5,NJSELI)                                    MODNET   1158
                OVPHS1=EQPI(6,NJSELI)                                   MODNET   1159
                GOTO 820                                                MODNET   1160
                ENDIF                                                   MODNET   1161
          ENDIF                                                         MODNET   1162
C                                                                       MODNET   1163
C   FOR OTHER SECTIONS STORE THE SECTION DATA                           MODNET   1164
C                                                                       MODNET   1165
         ELSE                                                           MODNET   1166
C                                                                       MODNET   1167
          ISECT=ISECT+1                                                 MODNET   1168
          YMAG=PSELIN(1,II)*PSELIN(1,II)+PSELIN(2,II)*PSELIN(2,II)      MODNET   1169
          ZREAL=PSELIN(1,II)/YMAG                                       MODNET   1170
          ZIMAG=PSELIN(2,II)/YMAG                                       MODNET   1171
          ZCX(ISECT)=CMPLX(ZREAL,ZIMAG)                                 MODNET   1172
          Y1CX(ISECT)=CMPLX(PSELIN(3,II),PSELIN(4,II))                  MODNET   1173
          Y2CX(ISECT)=CMPLX(PSELIN(5,II),PSELIN(6,II))                  MODNET   1174
C                                                                       MODNET   1175
C   ENDIF CNEXTS(2,II).EQ.ISCKT                                         MODNET   1176
C                                                                       MODNET   1177
          ENDIF                                                         MODNET   1178
C                                                                       MODNET   1179
 820      CONTINUE                                                      MODNET   1180
 825      CONTINUE                                                      MODNET   1181
C                                                                       MODNET   1182
          IF(KSECT.EQ.0)THEN                                            MODNET   1183
          IEBK=1                                                        MODNET   1184
       WRITE(MSG(1),3600)                                               MODNET   1185
       MSG(2)='     '//CARD1(1:48)                                      MODNET   1186
       MSG(3)='     '//CARD1(49:107)                                    MODNET   1187
       CALL PRTMSG(3)                                                   MODNET   1188
          GOTO 1100                                                     MODNET   1189
          ENDIF                                                         MODNET   1190
C                                                                       MODNET   1191
C   FIND AND STORE THE PI EQUIVALENT WITHE THE CAPACITOR FLASHED        MODNET   1192
C                                                                       MODNET   1193
          IF (IPOS.EQ.IPOS1) THEN                                       MODNET   1194
             REQ=0.001                                                  MODNET   1195
             XEQ=0.0                                                    MODNET   1196
             G1EQ=EQPI(3,NJSELI)                                        MODNET   1197
             B1EQ=EQPI(4,NJSELI)                                        MODNET   1198
             G2EQ=EQPI(5,NJSELI)                                        MODNET   1199
             B2EQ=EQPI(6,NJSELI)                                        MODNET   1200
          ELSE                                                          MODNET   1201
             CALL ABCD(ISECT,ZCX,Y1CX,Y2CX,REQ,XEQ,G1EQ,B1EQ,G2EQ,B2EQ) MODNET   1202
          END IF                                                        MODNET   1203
C                                                                       MODNET   1204
          YMAG=REQ*REQ+XEQ*XEQ                                          MODNET   1205
          EQPI(7,NJSELI)=REQ/YMAG                                       MODNET   1206
          EQPI(8,NJSELI)=XEQ/YMAG                                       MODNET   1207
          EQPI(9,NJSELI)=G1EQ                                           MODNET   1208
          EQPI(10,NJSELI)=B1EQ                                          MODNET   1209
          EQPI(11,NJSELI)=G2EQ                                          MODNET   1210
          EQPI(12,NJSELI)=B2EQ                                          MODNET   1211
          XREAL=EQPI(7,NJSELI)                                          MODNET   1212
          XIMAG=EQPI(8,NJSELI)                                          MODNET   1213
          VMG=EQPI(9,NJSELI)                                            MODNET   1214
          VPHS=EQPI(10,NJSELI)                                          MODNET   1215
          VMG1=EQPI(11,NJSELI)                                          MODNET   1216
          VPHS1=EQPI(12,NJSELI)                                         MODNET   1217
C                                                                       MODNET   1218
          GOTO 840                                                      MODNET   1219
C                                                                       MODNET   1220
C     FOR THE TRANFORMER BRANCH, OBTAIN AND WRITE THE G & B IN IU12     MODNET   1221
C                                                                       MODNET   1222
  860  IF(JNL.LT.0)THEN                                                 MODNET   1223
       NLFK=NLFI                                                        MODNET   1224
       NLFI=NLFJ                                                        MODNET   1225
       NLFJ=NLFK                                                        MODNET   1226
       ENDIF                                                            MODNET   1227
       IFOUND=1                                                         MODNET   1228
C                                                                       MODNET   1229
       IF(ITYP.NE.ISOC(18))GOTO 870                                     MODNET   1230
C      IF(IFOUND.EQ.0)THEN                                              MODNET   1231
C       GKK=0.0                                                         MODNET   1232
C       BKK=0.0                                                         MODNET   1233
C       GJJ=0.0                                                         MODNET   1234
C       BJJ=0.0                                                         MODNET   1235
C       GJK=0.0                                                         MODNET   1236
C       BJK=0.0                                                         MODNET   1237
C       GKJ=0.0                                                         MODNET   1238
C       BKJ=0.0                                                         MODNET   1239
C       GOTO 880                                                        MODNET   1240
C      ENDIF                                                            MODNET   1241
         GBUSX=OXREAL                                                   MODNET   1242
         BBUSX=OXIMAG                                                   MODNET   1243
         PHS=-OVPHS/57.29578                                            MODNET   1244
         XONR=ABS(OVMG)                                                 MODNET   1245
         FACT=XONR*XONR                                                 MODNET   1246
         GKK=GBUSX                                                      MODNET   1247
         BKK=-BBUSX                                                     MODNET   1248
         GJJ=GBUSX/FACT                                                 MODNET   1249
         BJJ=-BBUSX/FACT                                                MODNET   1250
         COSO=COS(PHS)/XONR                                             MODNET   1251
         SINO=SIN(PHS)/XONR                                             MODNET   1252
         GJK=-GBUSX*COSO+BBUSX*SINO                                     MODNET   1253
         BJK=GBUSX*SINO+BBUSX*COSO                                      MODNET   1254
         GKJ=-(GBUSX*COSO+BBUSX*SINO)                                   MODNET   1255
         BKJ=-GBUSX*SINO+BBUSX*COSO                                     MODNET   1256
 880     ISCARD=ISCARD+1                                                MODNET   1257
           IF(OVMG.GT.0.0)THEN                                          MODNET   1258
           WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GJJ,BJJ,GKK,BKK,   MODNET   1259
     &     GJK,BJK,GKJ,BKJ,NMLINE,NJSELI                                MODNET   1260
           ELSE                                                         MODNET   1261
           WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GKK,BKK,GJJ,BJJ,   MODNET   1262
     &     GKJ,BKJ,GJK,BJK,NMLINE,NJSELI                                MODNET   1263
           ENDIF                                                        MODNET   1264
C                                                                       MODNET   1265
 870       CONTINUE                                                     MODNET   1266
C                                                                       MODNET   1267
C   TRANSFORMER BRANCHES                                                MODNET   1268
C                                                                       MODNET   1269
         GBUSX=XREAL                                                    MODNET   1270
         BBUSX=XIMAG                                                    MODNET   1271
         PHS=-VPHS/57.29578                                             MODNET   1272
         XONR=ABS(VMG)                                                  MODNET   1273
         FACT=XONR*XONR                                                 MODNET   1274
         GKK=GBUSX                                                      MODNET   1275
         BKK=-BBUSX                                                     MODNET   1276
         GJJ=GBUSX/FACT                                                 MODNET   1277
         BJJ=-BBUSX/FACT                                                MODNET   1278
         COSO=COS(PHS)/XONR                                             MODNET   1279
         SINO=SIN(PHS)/XONR                                             MODNET   1280
         GJK=-GBUSX*COSO+BBUSX*SINO                                     MODNET   1281
         BJK=GBUSX*SINO+BBUSX*COSO                                      MODNET   1282
         GKJ=-(GBUSX*COSO+BBUSX*SINO)                                   MODNET   1283
         BKJ=-GBUSX*SINO+BBUSX*COSO                                     MODNET   1284
           ISCARD=ISCARD+1                                              MODNET   1285
           IF(VMG.GT.0.0)THEN                                           MODNET   1286
           WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GJJ,BJJ,GKK,BKK,   MODNET   1287
     &     GJK,BJK,GKJ,BKJ,NMLINE,NJSELI                                MODNET   1288
           ELSE                                                         MODNET   1289
           WRITE(IU12,2160)JTYP,NLFI,NLFJ,ICKT,ISCKT,GKK,BKK,GJJ,BJJ,   MODNET   1290
     &     GKJ,BKJ,GJK,BJK,NMLINE,NJSELI                                MODNET   1291
           ENDIF                                                        MODNET   1292
         GOTO 1010                                                      MODNET   1293
C                                                                       MODNET   1294
C                                                                       MODNET   1295
  840  IF(JNL.LT.0)THEN                                                 MODNET   1296
       NLFK=NLFI                                                        MODNET   1297
       NLFI=NLFJ                                                        MODNET   1298
       NLFJ=NLFK                                                        MODNET   1299
       ENDIF                                                            MODNET   1300
       IFOUND=1                                                         MODNET   1301
  890  CONTINUE                                                         MODNET   1302
      IF(IFOUND.EQ.0)THEN                                               MODNET   1303
      OXREAL=0.0                                                        MODNET   1304
      OXIMAG=0.0                                                        MODNET   1305
      OVMG=0.0                                                          MODNET   1306
      OVPHS=0.0                                                         MODNET   1307
      OVMG1=0.0                                                         MODNET   1308
      OVPHS1=0.0                                                        MODNET   1309
      ENDIF                                                             MODNET   1310
C                                                                       MODNET   1311
      ISCARD=ISCARD+1                                                   MODNET   1312
      WRITE(IU12,2150)JTYP,NLFI,NLFJ,ICKT,ISCKT,OXREAL,OXIMAG,OVMG,OVPHSMODNET   1313
     &,OVMG1,OVPHS1,NMLINE,NJSELI                                       MODNET   1314
C                                                                       MODNET   1315
 900  CONTINUE                                                          MODNET   1316
C      IF(IWRITE.EQ.0)REWIND IU12                                       MODNET   1317
      ISCARD=ISCARD+1                                                   MODNET   1318
       WRITE(IU12,2150)JTYP,NLFI,NLFJ,ICKT,ISCKT,XREAL,XIMAG,VMG,VPHS   MODNET   1319
     & ,VMG1,VPHS1,NMLINE,NJSELI                                        MODNET   1320
C       WRITE(IU6,2150)JTYP,NLFI,NLFJ,ICKT,ISCKT,XREAL,XIMAG,VMG,VPHS   MODNET   1321
C     & ,VMG1,VPHS1,NMLINE,NJSELI                                       MODNET   1322
C                                                                       MODNET   1323
C                                                                       MODNET   1324
 1010 CONTINUE                                                          MODNET   1325
C                                                                       MODNET   1326
      GMAG=XREAL**2+XIMAG**2                                            MODNET   1327
      IF(GMAG.GT.1.0E-6)THEN                                            MODNET   1328
       ZREAL=XREAL/GMAG                                                 MODNET   1329
       ZIMAG=XIMAG/GMAG                                                 MODNET   1330
      ELSE                                                              MODNET   1331
       ZREAL=0.                                                         MODNET   1332
       ZIMAG=0.                                                         MODNET   1333
      ENDIF                                                             MODNET   1334
C      IF(ISPR.EQ.1)THEN                                                MODNET   1335
C      WRITE(IU17,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),    MODNET   1336
C     1NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREAL,ZIM      MODNET   1337
C     2AG,VMG,VPHS,VMG1,VPHS1                                           MODNET   1338
C      WRITE(IU6,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),     MODNET   1339
C     1NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREAL,ZIM      MODNET   1340
C     2AG,VMG,VPHS,VMG1,VPHS1                                           MODNET   1341
C      ELSE                                                             MODNET   1342
C      WRITE(IU17,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),    MODNET   1343
C     1NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREAL,ZIM      MODNET   1344
C     2AG,VMG,VPHS                                                      MODNET   1345
C      WRITE(IU6,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3),     MODNET   1346
C     1NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREAL,ZIM      MODNET   1347
C     2AG,VMG,VPHS                                                      MODNET   1348
C      ENDIF                                                            MODNET   1349
      IF(JTYP.EQ.1.OR.JTYP.EQ.4.OR.JTYP.EQ.5.OR.JTYP.EQ.8.OR.           MODNET   1350
     *   JTYP.EQ.11.OR.JTYP.EQ.15.OR.JTYP.EQ.17)THEN                    MODNET   1351
C         WRITE(IU17,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)  MODNET   1352
C     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT      MODNET   1353
C     *         ,ZREAL,ZIMAG,VMG                                        MODNET   1354
         WRITE(IU6,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)    MODNET   1355
     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT       MODNET   1356
     *         ,ZREAL,ZIMAG,VMG                                         MODNET   1357
      ELSEIF(JTYP.EQ.2.OR.JTYP.EQ.6.OR.JTYP.EQ.12.OR.JTYP.EQ.18)THEN    MODNET   1358
C         WRITE(IU17,2410) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)  MODNET   1359
C     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT      MODNET   1360
C     *         ,ZREAL,ZIMAG,VMG,VPHS                                   MODNET   1361
         WRITE(IU6,2410) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)    MODNET   1362
     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT       MODNET   1363
     *         ,ZREAL,ZIMAG,VMG,VPHS                                    MODNET   1364
      ELSEIF(JTYP.EQ.14)THEN                                            MODNET   1365
C         WRITE(IU17,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)  MODNET   1366
C     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREALMODNET   1367
         WRITE(IU6,2400) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)    MODNET   1368
     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT,ZREAL MODNET   1369
      ELSE                                                              MODNET   1370
C         WRITE(IU17,2420) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)  MODNET   1371
C     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT      MODNET   1372
C     *         ,ZREAL,ZIMAG,VMG,VPHS,VMG1,VPHS1                        MODNET   1373
         WRITE(IU6,2420) ITYP,NOLDI,INAME(II1),INAME(II2),INAME(II3)    MODNET   1374
     1         ,NOLDJ,INAME(JJ1),INAME(JJ2),INAME(JJ3),ICKT,ISCKT       MODNET   1375
     *         ,ZREAL,ZIMAG,VMG,VPHS,VMG1,VPHS1                         MODNET   1376
      ENDIF                                                             MODNET   1377
C                                                                       MODNET   1378
C      END FILE 12                                                      MODNET   1379
C                                                                       MODNET   1380
 1100  CONTINUE                                                         MODNET   1381
C=                                                                      MODNET   1382
      NL=NXL                                                            MODNET   1383
      ITRF=ITRFX                                                        MODNET   1384
C=                                                                      MODNET   1385
C                                                                       MODNET   1386
      IF(IEBK.NE.0)THEN                                                 MODNET   1387
      MSG(1)='MODNET: NETWORK SWITCHING DATA ERROR'                     MODNET   1388
      CALL ASTOP(MSG(1),36)                                             MODNET   1389
      ENDIF                                                             MODNET   1390
C                                                                       MODNET   1391
 1200 CONTINUE                                                          MODNET   1392
C                                                                       MODNET   1393
      IF(ISTORE.EQ.2)THEN                                               MODNET   1394
      REWIND IU3                                                        MODNET   1395
      WRITE(IU3)NL,ITRF,NLFBUS                                          MODNET   1396
      CALL FLWR(IU3,0,NL*5,GBFT)                                        MODNET   1397
      CALL IFWR(IU3,0,NXTR,ITRAN)                                       MODNET   1398
      IF(ITRF.NE.0)CALL FLWR(IU3,0,ITRF*2,TRANS)                        MODNET   1399
      CALL IHWR(IU3,0,NL,LTRANC)                                        MODNET   1400
C                                                                       MODNET   1401
C      RESTORE AND UPDATE THE PI-LINE DATA                              MODNET   1402
C                                                                       MODNET   1403
      IF(NSEL .NE.0)THEN                                                MODNET   1404
      WRITE(IU3)NSEL                                                    MODNET   1405
      CALL FLWR(IU3,0,18*NSEL,EQPI)                                     MODNET   1406
      CALL FLWR(IU3,0,24*NSEL,PSELIN)                                   MODNET   1407
      CALL IHWR(IU3,0,6*NSEL,LCONE)                                     MODNET   1408
      CALL IHWR(IU3,0,12*NSEL,NEXTSL)                                   MODNET   1409
      ENDIF                                                             MODNET   1410
C                                                                       MODNET   1411
C       RESTORE THE ORIGINAL LINKNET                                    MODNET   1412
C                                                                       MODNET   1413
      WRITE(IU3)LLNET                                                   MODNET   1414
      CALL IFWR(IU3,0,LLNET*2,LINEPO)                                   MODNET   1415
      CALL IFWR(IU3,0,LLNET,IARCCT)                                     MODNET   1416
      CALL IFWR(IU3,0,NL,LISMON)                                        MODNET   1417
      ENDIF                                                             MODNET   1418
C                                                                       MODNET   1419
      RETURN                                                            MODNET   1420
C                                                                       MODNET   1421
 2000 FORMAT(A3,1X,I5,10X,4F10.5)                                       MODNET   1422
 2050 FORMAT(I3,1X,I5,10X,2F10.4,2F10.5)                                MODNET   1423
 2100 FORMAT (A3,1X,2I5,1X,2A2,70X,F10.5)                               MODNET   1424
 2150 FORMAT (I3,1X,2I5,1X,2A2,6F10.5,2I5)                              MODNET   1425
 2160 FORMAT (I3,1X,2I5,1X,2A2,8F10.3,2I5)                              MODNET   1426
 2200 FORMAT(19X,6F10.5)                                                MODNET   1427
C 2300 FORMAT (///10X,'SWITCHING OF NETWORK :-',/,10X,21('-'),/10X,'TYPEMODNET   1428
C     &1X,'FROM',15X,'TO',13X,'AREA',' CT#','   R',6X,'   X',10X,'BC',  MODNET   1429
C     &'HRG/ONR',4X,'PHSIFT', 2X,'(FOR LINE / TRANSFORMER)',/,          MODNET   1430
C     &15X,'BUS#',2X,'BUS NAME',5X,'BUS#',2X,'BUS NAME',10X,'  R',6X,   MODNET   1431
C     &'   X',9X,'  G1',6X,'  B1',7X,'   G2',6X,'   B2',1X,             MODNET   1432
C     &'(FOR PI-LINE)',/)                                               MODNET   1433
C 2400 FORMAT (10X,A3,2(1X,I5,1X,3A4),1X,2A2,2F10.5,4(2X,F10.5))        MODNET   1434
 2300 FORMAT(///,57X,'SWITCHING OF NETWORK',/,57X,20('='),/,1X,131('_') MODNET   1435
     *,/,' :    :FROM:',12X,': TO :',12X,':   :   :',9(8X,':'),/        MODNET   1436
     *,' :TYPE',2(':BUS#:  BUS NAME  ')                                 MODNET   1437
     *,':CID:SID:  R/G   :  X/B   :  BCHRG :   ONR  : PHSIFT '          MODNET   1438
     *,':   G1   :   B1   :   G2   :   B2:',/,' :____'                  MODNET   1439
     *,2(':____:____________'),':___:___:',9('________:'))              MODNET   1440
 2400 FORMAT(3X,A3,2(I5,1X,3A4),2(2X,A2),3F9.4)                         MODNET   1441
 2410 FORMAT(3X,A3,2(I5,1X,3A4),2(2X,A2),2F9.4,9X,2F9.4)                MODNET   1442
 2420 FORMAT(3X,A3,2(I5,1X,3A4),2(2X,A2),2F9.4,27X,4F9.4)               MODNET   1443
 2500 FORMAT(3X,A3,I5,1X,3A4,27X,F8.2,1X,F8.2)                          MODNET   1444
 3000 FORMAT(' *** ADDITION OF LINE OR TRANSFORMER '                    MODNET   1445
     &,' NOT ALLOWED THIS ITEM EXISTS ALREADY')                         MODNET   1446
 3010 FORMAT(5X,'CHECK THE SWITCHING DATA.')                            MODNET   1447
 3100 FORMAT(' *** ERROR ADDING ZERO IMPEDANCE LINE')                   MODNET   1448
 3200 FORMAT(' *** RECONNECTING OF LINE OR TRANSFORMER'                 MODNET   1449
     &,' NOT IN THE SYSTEM CHECK SWITCHING DATA')                       MODNET   1450
 3300 FORMAT(' *** RECONNECTING OF LINE OR TRANSFORMER'                 MODNET   1451
     &,' CONNECTED ALREADY CHECK SWITCHING DATA')                       MODNET   1452
 3400 FORMAT(' *** MODIFY LINE OR TRANSFORMER'                          MODNET   1453
     &,' NOT IN THE SYSTEM CHECK SWITCHING DATA')                       MODNET   1454
 3500 FORMAT(' *** ERROR ADDING SECTIONAL LINE FACILITY HAS NOT'        MODNET   1455
     &,' BEEN PROGRAMMED YET')                                          MODNET   1456
 3600 FORMAT(' *** ERROR SECTION DOES NOT EXIST,'                       MODNET   1457
     &,' CHECK YOUR SWITCHING DECK')                                    MODNET   1458
 3700 FORMAT(' *** RECONNECTING OF LINE OR TRANSFORMER '                MODNET   1459
     &,' NOT IN THE SYSTEM')                                            MODNET   1460
 3800 FORMAT(' *** RECONNECTING SECTIONAL LINE '                        MODNET   1461
     &,' THAT HAS ALREADY RECONNECTED')                                 MODNET   1462
 3900 FORMAT(' *** ERROR MODIFYING SECTIONAL LINE FACILITY HAS NOT'     MODNET   1463
     &,' BEEN PROGRAMMED YET')                                          MODNET   1464
 4000 FORMAT(' *** DISCONNECTING OF LINE OR TRANSFORMER '               MODNET   1465
     &,' NOT IN THE SYSTEM')                                            MODNET   1466
 4100 FORMAT(' *** ERROR DISCONNECTING A LINE OR TRANSFORMER ALREADY '  MODNET   1467
     &,'BEING DISCONNECTED.')                                           MODNET   1468
 4200 FORMAT(' *** DISCONNECTING SECTIONAL LINE '                       MODNET   1469
     &,' THAT HAS ALREADY DISCONNECTED')                                MODNET   1470
 4300 FORMAT(' *** ERROR CAPACITOR NOT FLASHED'                         MODNET   1471
     &,' CHECK YOUR SWITCHING DECK')                                    MODNET   1472
 4400 FORMAT(' *** ERROR CAPACITOR FLASHED ALREADY'                     MODNET   1473
     &,' CHECK YOUR SWITCHING DECK')                                    MODNET   1474
 4500 FORMAT(' ZIL # :NZI  NZJ ',2I10)                                  MODNET   1475
 4600 FORMAT(' ALTERED IMSK ',20I5)                                     MODNET   1476
 4700 FORMAT(' MODNET B4 : LBRI NELI KTNO ',3I10)                       MODNET   1477
 4800 FORMAT(' MODNET AFTER : LBRI NELI KTNO ',3I10)                    MODNET   1478
 4900 FORMAT(' ORIGINAL IMSK : ',20I5)                                  MODNET   1479
 5000 FORMAT(' IN MODNET : XREAL , XIMAG = ' ,2E18.5)                   MODNET   1480
 5100 FORMAT(' *** ERROR BUS TIE BETWEEN BUS# ',2I6,                    MODNET   1481
     &' DOES NOT EXIST IN THE TABLE')                                   MODNET   1482
 5200 FORMAT(A3,3X,' FROM BUS NO.',I6,'  BUS NAME ',3A4,6X,             MODNET   1483
     &             '   TO BUS NO.',I6,'  BUS NAME ',3A4,3X,'CID ',A2)   MODNET   1484
C                                                                       MODNET   1485
      END                                                               MODNET   1486
